3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
8 Exit non-zero if any tests fail.
11 $(basename $0) WORKSPACE=/path/to/arvados [options]
15 --skip FOO Do not test the FOO component.
16 --only FOO Do not test anything except the FOO component.
17 --temp DIR Install components and dependencies under DIR instead of
18 making a new temporary directory. Implies --leave-temp.
19 --leave-temp Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20 Instead, show the path to give as --temp to reuse them in
21 subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23 You should provide GOPATH, GEMHOME, and VENVDIR options
24 from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28 (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30 Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32 Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34 Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36 Show all log messages, even when tests pass (also works
37 with services/keepstore_test etc.)
39 Print more debug messages
40 envvar=value Set \$envvar to value. Primarily useful for WORKSPACE,
41 *_test, and other examples shown above.
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
51 More information and background:
53 https://arvados.org/projects/arvados/wiki/Running_tests
58 apps/workbench_benchmark
59 apps/workbench_profile
62 services/arv-git-httpd
64 services/dockercleaner
71 services/crunch-dispatch-local
82 tools/crunchstat-summary
87 # First make sure to remove any ARVADOS_ variables from the calling
88 # environment that could interfere with the tests.
89 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
91 # Reset other variables that could affect our [tests'] behavior by
108 if [[ -z "$temp" ]]; then
109 # we didn't even get as far as making a temp dir
111 elif [[ -z "$temp_preserve" ]]; then
114 echo "Leaving behind temp dirs in $temp"
120 echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
125 for x in "${successes[@]}"
130 if [[ ${#failures[@]} == 0 ]]
132 echo "All test suites passed."
134 echo "Failures (${#failures[@]}):"
135 for x in "${failures[@]}"
144 create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
145 rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
147 rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
154 ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
155 || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
156 echo Checking dependencies:
157 echo -n 'virtualenv: '
158 virtualenv --version \
159 || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
162 || fatal "No go binary. See http://golang.org/doc/install"
164 gcc --version | egrep ^gcc \
165 || fatal "No gcc. Try: apt-get install build-essential"
167 find /usr/include -wholename '*fuse/fuse.h' \
168 || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
169 echo -n 'pyconfig.h: '
170 find /usr/include -name pyconfig.h | egrep --max-count=1 . \
171 || fatal "No pyconfig.h. Try: apt-get install python-dev"
173 PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
174 || fatal "No nginx. Try: apt-get install nginx"
176 perl -v | grep version \
177 || fatal "No perl. Try: apt-get install perl"
178 for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
179 echo -n "perl $mod: "
180 perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
181 || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
185 || fatal "No gitolite. Try: apt-get install gitolite3"
189 # i.e. rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
190 # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
191 if [[ -f "$1/$2" ]]; then
192 THEDATE=`date +%Y%m%d%H%M%S`
193 mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
194 gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
201 skip[apps/workbench_profile]=1
208 echo >&2 "$helpmessage"
217 only="$1"; skip[$1]=""; shift
224 only_install="$1"; shift
237 suite="${arg%%_test=*}"
239 testargs["$suite"]="$args"
242 eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
245 echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
252 echo 'Starting API server...'
254 && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
255 && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
256 && export ARVADOS_TEST_API_INSTALLED="$$" \
257 && (env | egrep ^ARVADOS)
260 start_nginx_proxy_services() {
261 echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
263 && python sdk/python/tests/run_test_server.py start_keep_proxy \
264 && python sdk/python/tests/run_test_server.py start_keep-web \
265 && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
266 && python sdk/python/tests/run_test_server.py start_nginx \
267 && export ARVADOS_TEST_PROXY_SERVICES=1
271 if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
272 unset ARVADOS_TEST_PROXY_SERVICES
274 && python sdk/python/tests/run_test_server.py stop_nginx \
275 && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
276 && python sdk/python/tests/run_test_server.py stop_keep-web \
277 && python sdk/python/tests/run_test_server.py stop_keep_proxy
279 if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
280 unset ARVADOS_TEST_API_HOST
282 && python sdk/python/tests/run_test_server.py stop
287 failures+=("($(basename $0) interrupted)")
294 echo "WORKSPACE=$WORKSPACE"
296 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
297 # Jenkins expects us to use this by default.
298 CONFIGSRC="$HOME/arvados-api-server"
301 # Clean up .pyc files that may exist in the workspace
303 find -name '*.pyc' -delete
305 if [[ -z "$temp" ]]; then
309 # Set up temporary install dirs (unless existing dirs were supplied)
310 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
312 if [[ -z "${!tmpdir}" ]]; then
313 eval "$tmpdir"="$temp/$tmpdir"
315 if ! [[ -d "${!tmpdir}" ]]; then
316 mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
320 setup_ruby_environment() {
321 if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
322 source "$HOME/.rvm/scripts/rvm"
324 elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
325 source "/usr/local/rvm/scripts/rvm"
331 if [[ "$using_rvm" == true ]]; then
332 # If rvm is in use, we can't just put separate "dependencies"
333 # and "gems-under-test" paths to GEM_PATH: passenger resets
334 # the environment to the "current gemset", which would lose
335 # our GEM_PATH and prevent our test suites from running ruby
336 # programs (for example, the Workbench test suite could not
337 # boot an API server or run arv). Instead, we have to make an
338 # rvm gemset and use it for everything.
340 [[ `type rvm | head -n1` == "rvm is a function" ]] \
343 # Put rvm's favorite path back in first place (overriding
344 # virtualenv, which just put itself there). Ignore rvm's
345 # complaint about not being in first place already.
346 rvm use @default 2>/dev/null
348 # Create (if needed) and switch to an @arvados-tests
349 # gemset. (Leave the choice of ruby to the caller.)
350 rvm use @arvados-tests --create \
351 || fatal 'rvm gemset setup'
355 # When our "bundle install"s need to install new gems to
356 # satisfy dependencies, we want them to go where "gem install
357 # --user-install" would put them. (However, if the caller has
358 # already set GEM_HOME, we assume that's where dependencies
359 # should be installed, and we should leave it alone.)
361 if [ -z "$GEM_HOME" ]; then
362 user_gempath="$(gem env gempath)"
363 export GEM_HOME="${user_gempath%%:*}"
365 PATH="$(gem env gemdir)/bin:$PATH"
367 # When we build and install our own gems, we install them in our
368 # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
369 # PATH so integration tests prefer them over other versions that
370 # happen to be installed in $user_gempath, system dirs, etc.
372 tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
373 PATH="$tmpdir_gem_home/bin:$PATH"
374 export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
376 echo "Will install dependencies to $(gem env gemdir)"
377 echo "Will install arvados gems to $tmpdir_gem_home"
378 echo "Gem search path is GEM_PATH=$GEM_PATH"
383 if [[ "$using_rvm" == true ]]; then
386 GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
390 gem_uninstall_if_exists() {
391 if gem list "$1\$" | egrep '^\w'; then
392 gem uninstall --force --all --executables "$1"
397 local venvdest="$1"; shift
398 if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
399 virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
401 "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
402 # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
403 "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
406 export PERLINSTALLBASE
407 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
410 mkdir -p "$GOPATH/src/git.curoverse.com"
411 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
412 || fatal "symlink failed"
414 setup_virtualenv "$VENVDIR" --python python2.7
415 . "$VENVDIR/bin/activate"
417 # Needed for run_test_server.py which is used by certain (non-Python) tests.
418 pip freeze 2>/dev/null | egrep ^PyYAML= \
419 || pip install PyYAML >/dev/null \
420 || fatal "pip install PyYAML failed"
422 # Preinstall forked version of libcloud, because nodemanager "pip install"
423 # won't pick it up by default.
424 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
425 || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
426 || fatal "pip install apache-libcloud failed"
428 # Uninstall old llfuse, because services/fuse "pip install" won't
429 # upgrade it by default.
430 if pip freeze | egrep '^llfuse==0\.41\.'; then
431 yes | pip uninstall 'llfuse<0.42'
434 # Deactivate Python 2 virtualenv
437 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
438 # Otherwise, skip dependent tests.
439 PYTHON3=$(which python3)
440 if [ "0" = "$?" ]; then
441 setup_virtualenv "$VENV3DIR" --python python3
444 skip[services/dockercleaner]=1
447 Warning: python3 could not be found
448 services/dockercleaner install and tests will be skipped
453 # Reactivate Python 2 virtualenv
454 . "$VENVDIR/bin/activate"
456 # Note: this must be the last time we change PATH, otherwise rvm will
458 setup_ruby_environment
462 if ! which bundler >/dev/null
464 gem install --user-install bundler || fatal 'Could not install bundler'
468 if [[ "$1" != "0" ]]; then
469 title "!!!!!! $2 FAILED !!!!!!"
470 failures+=("$2 (`timer`)")
472 successes+=("$2 (`timer`)")
481 echo -n "$(($SECONDS - $t0))s"
485 while ! do_test_once ${@} && [[ "$retry" == 1 ]]
487 read -p 'Try again? [Y/n] ' x
488 if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
497 if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
499 title "Running $1 tests"
501 if [[ "$2" == "go" ]]
503 covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
504 coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
505 # We do "go get -t" here to catch compilation errors
506 # before trying "go test". Otherwise, coverage-reporting
507 # mode makes Go show the wrong line numbers when reporting
508 # compilation errors.
509 if [[ -n "${testargs[$1]}" ]]
511 # "go test -check.vv giturl" doesn't work, but this
513 cd "$WORKSPACE/$1" && \
514 go get -t "git.curoverse.com/arvados.git/$1" && \
515 go test ${coverflags[@]} ${testargs[$1]}
517 # The above form gets verbose even when testargs is
518 # empty, so use this form in such cases:
519 go get -t "git.curoverse.com/arvados.git/$1" && \
520 go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
523 go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
524 rm "$WORKSPACE/tmp/.$covername.tmp"
525 elif [[ "$2" == "pip" ]]
527 # $3 can name a path directory for us to use, including trailing
528 # slash; e.g., the bin/ subdirectory of a virtualenv.
530 && "${3}python" setup.py test ${testargs[$1]}
531 elif [[ "$2" != "" ]]
538 checkexit $result "$1 tests"
539 title "End of $1 tests (`timer`)"
542 title "Skipping $1 tests"
547 if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
549 title "Running $1 install"
551 if [[ "$2" == "go" ]]
553 go get -t "git.curoverse.com/arvados.git/$1"
554 elif [[ "$2" == "pip" ]]
556 # $3 can name a path directory for us to use, including trailing
557 # slash; e.g., the bin/ subdirectory of a virtualenv.
559 # Need to change to a different directory after creating
560 # the source dist package to avoid a pip bug.
561 # see https://arvados.org/issues/5766 for details.
563 # Also need to install twice, because if it believes the package is
564 # already installed, pip it won't install it. So the first "pip
565 # install" ensures that the dependencies are met, the second "pip
566 # install" ensures that we've actually installed the local package
569 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
571 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
572 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
573 elif [[ "$2" != "" ]]
579 checkexit $? "$1 install"
580 title "End of $1 install (`timer`)"
582 title "Skipping $1 install"
587 txt="********** $1 **********"
588 printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
591 bundle_install_trylocal() {
594 echo "(Running bundle install --local. 'could not find package' messages are OK.)"
595 if ! bundle install --local --no-deployment; then
596 echo "(Running bundle install again, without --local.)"
597 bundle install --no-deployment
604 cd "$WORKSPACE/doc" \
605 && bundle_install_trylocal \
613 with_test_gemset gem_uninstall_if_exists "$gemname" \
614 && cd "$WORKSPACE/$srcpath" \
615 && bundle_install_trylocal \
616 && gem build "$gemname.gemspec" \
617 && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
621 install_gem arvados sdk/ruby
623 do_install sdk/ruby ruby_sdk
626 cd "$WORKSPACE/sdk/perl" \
627 && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
628 && make install INSTALLDIRS=perl
630 do_install sdk/perl perl_sdk
633 install_gem arvados-cli sdk/cli
635 do_install sdk/cli cli
637 install_login-sync() {
638 install_gem arvados-login-sync services/login-sync
640 do_install services/login-sync login-sync
642 # Install the Python SDK early. Various other test suites (like
643 # keepproxy) bring up run_test_server.py, which imports the arvados
644 # module. We can't actually *test* the Python SDK yet though, because
645 # its own test suite brings up some of those other programs (like
647 declare -a pythonstuff
653 tools/crunchstat-summary
655 for p in "${pythonstuff[@]}"
659 if [ -n "$PYTHON3" ]; then
660 do_install services/dockercleaner pip "$VENV3DIR/bin/"
663 install_apiserver() {
664 cd "$WORKSPACE/services/api" \
665 && RAILS_ENV=test bundle_install_trylocal
667 rm -f config/environments/test.rb
668 cp config/environments/test.rb.example config/environments/test.rb
670 if [ -n "$CONFIGSRC" ]
672 for f in database.yml application.yml
674 cp "$CONFIGSRC/$f" config/ || fatal "$f"
678 # Fill in a random secret_token and blob_signing_key for testing
679 SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
680 BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
682 sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
683 sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
685 # Set up empty git repo (for git tests)
687 sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
690 mkdir -p $GITDIR/test
693 && git config user.email "jenkins@ci.curoverse.com" \
694 && git config user.name "Jenkins, CI" \
697 && git commit -m 'initial commit'
699 # Clear out any lingering postgresql connections to the test
700 # database, so that we can drop it. This assumes the current user
701 # is a postgresql superuser.
702 cd "$WORKSPACE/services/api" \
703 && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
704 && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
706 cd "$WORKSPACE/services/api" \
707 && RAILS_ENV=test bundle exec rake db:drop \
708 && RAILS_ENV=test bundle exec rake db:setup \
709 && RAILS_ENV=test bundle exec rake db:fixtures:load
711 do_install services/api apiserver
720 services/arv-git-httpd
726 services/datamanager/summary
727 services/datamanager/collection
728 services/datamanager/keep
730 services/crunch-dispatch-local
734 for g in "${gostuff[@]}"
739 install_workbench() {
740 cd "$WORKSPACE/apps/workbench" \
741 && mkdir -p tmp/cache \
742 && RAILS_ENV=test bundle_install_trylocal
744 do_install apps/workbench workbench
746 test_doclinkchecker() {
750 ARVADOS_API_HOST=qr1hi.arvadosapi.com
751 # Make sure python-epydoc is installed or the next line won't
753 PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
756 do_test doc doclinkchecker
761 cd "$WORKSPACE/services/api" \
762 && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
764 do_test services/api apiserver
766 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
767 # because we don't need to start up the api server for subsequent tests.
768 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
769 rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
776 cd "$WORKSPACE/sdk/ruby" \
777 && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
779 do_test sdk/ruby ruby_sdk
782 cd "$WORKSPACE/sdk/cli" \
783 && mkdir -p /tmp/keep \
784 && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
789 cd "$WORKSPACE/services/login-sync" \
790 && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
792 do_test services/login-sync login-sync
794 for p in "${pythonstuff[@]}"
798 do_test services/dockercleaner pip "$VENV3DIR/bin/"
800 for g in "${gostuff[@]}"
806 start_nginx_proxy_services \
807 && cd "$WORKSPACE/apps/workbench" \
808 && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
810 do_test apps/workbench workbench
812 test_workbench_benchmark() {
813 start_nginx_proxy_services \
814 && cd "$WORKSPACE/apps/workbench" \
815 && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
817 do_test apps/workbench_benchmark workbench_benchmark
819 test_workbench_profile() {
820 start_nginx_proxy_services \
821 && cd "$WORKSPACE/apps/workbench" \
822 && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
824 do_test apps/workbench_profile workbench_profile